<HTML><TITLE>Dummy.c</TITLE><BODY><PRE>/*____________________________________________________________________________*\

 Copyright (c) 1997 John Roy. All rights reserved.

 These sources, libraries and applications are
 FREE FOR COMMERCIAL AND NON-COMMERCIAL USE
 as long as the following conditions are adhered to.

 Redistribution and use in source and binary forms, with or without
 modification, are permitted provided that the following conditions
 are met:

 1. Redistributions of source code must retain the above copyright
    notice, this list of conditions and the following disclaimer. 

 2. Redistributions in binary form must reproduce the above copyright
    notice, this list of conditions and the following disclaimer in
    the documentation and/or other materials provided with the
    distribution.

 3. Redistributions of any form whatsoever and all advertising materials 
    mentioning features must contain the following
    acknowledgment:
    "This product includes software developed by John Roy
    (http://www.johnroy.com/pi3/)."

 THIS SOFTWARE IS PROVIDED ``AS IS'' AND ANY EXPRESSED OR IMPLIED
 WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
 IN NO EVENT SHALL THE AUTHORS OR ITS CONTRIBUTORS BE LIABLE FOR ANY
 DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE
 GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT,
 STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED
 OF THE POSSIBILITY OF SUCH DAMAGE.

 *____________________________________________________________________________*|
 *
 * $Source: Dummy.c$
 * $Date: Sun Aug 10 06:37:32 1997$
 *
 Description:
	<A HREF="/pidocs/Objects/Plugins.html#Dummy">Dummy</A> handler module.

\*____________________________________________________________________________*/
/* $SourceTop:$ */

#include &ltassert.h>

#include "Pi3API.h"


/*____________________________________________________________________________*\
 *
 Description:
	Documentation
\*____________________________________________________________________________*/
#if 0
	/*
	** HTML documentation for this handler
	*/
/*___+++HTMLDOC_BEGIN+++___*/
Name:
	<A HREF="/pidocs/Objects/Plugins.html#Dummy">Dummy</A>

Description:
	This handler does not do anything. It is useful as a template and
	as a substitute for handlers that are removed from distribution.

Options:
&lt!--
&ltH5>Overview&lt/H5>
&ltTABLE BORDER=1>
&ltTH>Option
&ltTH>Default
&ltTH>Values
&ltTH>Short Description
&ltTH>Example(s)

&ltTR>
&ltTD><A HREF="/pidocs/Objects/Pi3API.html#Pi3Expression">Pi3Expression</A>
&ltTD>+
&ltTD>A <A HREF="/pidocs/Objects/Pi3API.html#Pi3Expression">Pi3Expression</A>
&ltTD>Expression to place in debug log
&ltTD>Pi3Expression="$c/* value of Content-Type */"

&lt/TABLE>
&ltSTRONG>-&lt/STRONG> in the &ltIT>default&lt/IT> indicates no default&ltBR>
&ltSTRONG>+&lt/STRONG> in the &ltIT>default&lt/IT> indicates the field is mandatory&ltBR>

&ltH4>Description of Options&lt/H4>
&ltH5>
	<A HREF="/pidocs/Objects/Pi3API.html#Pi3Expression">Pi3Expression</A>
&lt/H5>
<A HREF="/pidocs/Objects/Pi3API.html#Pi3Expression">Pi3Expression</A> to write in the debug log.
-->

Phase:
	All phases

Returns:
	PIAPI_COMPLETED

Note:
Example:
	&ltPRE>
	&ltObject&gt
		Name <A HREF="/pidocs/Objects/Plugins.html#Dummy">Dummy</A>
		Class DummyClass
		Variable3 "Value3"
	&lt/Object&gt

	&ltObject&gt
		...
		Handle <A HREF="/pidocs/Objects/Plugins.html#Dummy">Dummy</A> Variable1="Value1" Variable2="Value2"
		...
	&lt/Object&gt
	&lt/PRE>
/*___+++HTMLDOC_END+++___*/
#endif

/*____________________________________________________________________________*\
 *
 Description:
\*____________________________________________________________________________*/
struct _Dummy
{
	int xxx;
};
typedef struct _Dummy Dummy;

/*____________________________________________________________________________*\
 *
 Function:
 Synopsis:
 Description:
\*____________________________________________________________________________*/
int Dummy_fnParameter( void *pData, const char *pVar, const char *pVal,
	const char *pWhere )
{
	PIObject *pObject = (PIObject *)pData;
	<A HREF="/pidocs/Objects/Plugins.html#Dummy">Dummy</A> *pDummy = (<A HREF="/pidocs/Objects/Plugins.html#Dummy">Dummy</A> *)<A HREF="/pidocs/APISpec/Pi2API.html#PIObject_getUserData">PIObject_getUserData</A>( pObject );
	(void)pDummy;
	assert( pVar );
	assert( pVal );

#if 0
	if ( !<A HREF="/pidocs/APISpec/PiAPI.html#PIUtil_stricmp">PIUtil_stricmp</A>( pVar, "Variable1" ) )
		{
		xxx = pVal;
		}
#endif
	if ( 1 )
		{
		}
	else
		{
		/* ---
		Configuration error
		--- */
		<A HREF="/pidocs/APISpec/Pi2API.html#PILog_addMessage">PILog_addMessage</A>(
			<A HREF="/pidocs/APISpec/Pi2API.html#PIObject_getDB">PIObject_getDB</A>( pObject ),
			<A HREF="/pidocs/APISpec/Pi2API.html#PIObject_getConfigurationDB">PIObject_getConfigurationDB</A>( pObject ),
			PILOG_ERROR, "Dummy: %sUnknown directive '%s'.", pWhere, pVar );
		return 0;
		};
	return 1;
}

/*____________________________________________________________________________*\
 *
 Function:
 Synopsis:
 Description:
\*____________________________________________________________________________*/
int Dummy_init( <A HREF="/pidocs/Objects/Plugins.html#Dummy">Dummy</A> *pDummy, PIObject *pObject, int iArgc,
	const char *ppArgv[] )
{
	int iRet = <A HREF="/pidocs/APISpec/Pi2API.html#PIObject_readParameters">PIObject_readParameters</A>( pObject, iArgc, ppArgv,
		Dummy_fnParameter, pObject );

	/* --- set defaults --- */
	if ( iRet )
		{
#if 0
		pDummy->xxx = "yyy"
#endif
		};

	return iRet;
}

/*____________________________________________________________________________*\
 *
 Function:
 Synopsis:
 Description:
\*____________________________________________________________________________*/
PUBLIC_PIAPI int Dummy_onClassLoad( PIClass_LoadAction eLoad, int i,
	const char *a[] )
{
	return PIAPI_COMPLETED;
}

/*____________________________________________________________________________*\
 *
 Function:
 Synopsis:
 Description:
\*____________________________________________________________________________*/
PUBLIC_PIAPI int Dummy_constructor( PIObject *pObj,
	int iArgc, const char *ppArgv[] )
{
	<A HREF="/pidocs/Objects/Plugins.html#Dummy">Dummy</A> *pDummy = <A HREF="/pidocs/APISpec/PiAPI.html#PIUtil_malloc">PIUtil_malloc</A>( sizeof( <A HREF="/pidocs/Objects/Plugins.html#Dummy">Dummy</A> ) );
	<A HREF="/pidocs/APISpec/Pi2API.html#PIObject_setUserData">PIObject_setUserData</A>( pObj, pDummy );
	if ( !Dummy_init( pDummy, pObj, iArgc, ppArgv ) )
		{
		return PIAPI_ERROR;
		};
	return PIAPI_COMPLETED;
}

/*____________________________________________________________________________*\
 *
 Function:
 Synopsis:
 Description:
\*____________________________________________________________________________*/
PUBLIC_PIAPI int Dummy_copyConstructor( PIObject *o, int i, const char *a[] )
{
	return PIAPI_ERROR;
}

/*____________________________________________________________________________*\
 *
 Function:
 Synopsis:
 Description:
\*____________________________________________________________________________*/
#define MSG "\
&ltHTML>\
&ltBODY BACKGROUND=\"/icons/Pi3Tile.gif\" BGCOLOR=\"#FFFFFF\">\
&ltTITLE>Stub Handler&lt/TITLE>\
&ltH1>Stub Handler&lt/H1>\
This requested handler service has not been added loaded into this server.&ltBR>\
&lt/BODY>&lt/HTML>\
"
PUBLIC_PIAPI int Dummy_execute( PIObject *pObj,
	int iArgc, const char *ppArgv[] )
{
	PIHTTP *pPIHTTP;

	if ( iArgc&lt1 )
		{ return PIAPI_ERROR; };

	pPIHTTP = (PIHTTP *)*ppArgv;

	/* ---
	If this is a handler phase then send a message
	--- */
	if ( pPIHTTP->ciPhase==PH_HANDLE )
		{
		PIDB *pR = pPIHTTP->pResponseDB;
/*		PIDB *pQ = pPIHTTP->pRequestDB; */
		PIIOBuffer *pB = pPIHTTP->pBuffer;

		/* ---
		Send headers
		-- */
        if (    <A HREF="/pidocs/APISpec/Pi3API.html#HTTPCore_sendGeneralHeaders">HTTPCore_sendGeneralHeaders</A>( pPIHTTP ) ||
                <A HREF="/pidocs/APISpec/Pi3API.html#HTTPCore_sendEntityHeaders">HTTPCore_sendEntityHeaders</A>( pPIHTTP, pR ) )
            {
			return PIAPI_ERROR;
			};

		/* ---
		Send a brief message
		--- */
		<A HREF="/pidocs/APISpec/Pi3API.html#PIIOBuffer_writeLn">PIIOBuffer_writeLn</A>( pB, MSG, sizeof(MSG), PIIOBUF_NONE );
		};

	return PIAPI_COMPLETED;
}

/*____________________________________________________________________________*\
 *
 Function:
 Synopsis:
 Description:
\*____________________________________________________________________________*/
PUBLIC_PIAPI int Dummy_destructor( PIObject *pObj, int i, const char *a[] )
{
	<A HREF="/pidocs/APISpec/PiAPI.html#PIUtil_free">PIUtil_free</A>( <A HREF="/pidocs/APISpec/Pi2API.html#PIObject_getUserData">PIObject_getUserData</A>( pObj ) );
	return PIAPI_COMPLETED;
}

#if 0
/*___+++CNF_BEGIN+++___*/
	&ltClass>
		Name DummyClass
		Type LogicExtension
		Library Plugins
		OnClassLoad Dummy_onClassLoad
		Constructor Dummy_constructor
		CopyConstructor Dummy_copyConstructor
		Destructor Dummy_destructor
		Execute Dummy_execute
	&lt/Class>

	&ltObject>
		Name <A HREF="/pidocs/Objects/Plugins.html#Dummy">Dummy</A>
		Class DummyClass
	&lt/Object>

/*___+++CNF_END+++___*/
#endif

</PRE></BODY></HTML>