<HTML><TITLE>ViewEnv.c</TITLE><BODY><PRE>/*____________________________________________________________________________*\
 *

 Copyright (c) 1997 John Roy. All rights reserved.

 These sources, libraries and applications are
 FREE FOR COMMERCIAL AND NON-COMMERCIAL USE
 as long as the following conditions are adhered to.

 Redistribution and use in source and binary forms, with or without
 modification, are permitted provided that the following conditions
 are met:

 1. Redistributions of source code must retain the above copyright
    notice, this list of conditions and the following disclaimer. 

 2. Redistributions in binary form must reproduce the above copyright
    notice, this list of conditions and the following disclaimer in
    the documentation and/or other materials provided with the
    distribution.

 3. Redistributions of any form whatsoever and all advertising materials 
    mentioning features must contain the following
    acknowledgment:
    "This product includes software developed by John Roy
    (http://www.johnroy.com/pi3/)."

 THIS SOFTWARE IS PROVIDED ``AS IS'' AND ANY EXPRESSED OR IMPLIED
 WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
 IN NO EVENT SHALL THE AUTHORS OR ITS CONTRIBUTORS BE LIABLE FOR ANY
 DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE
 GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT,
 STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED
 OF THE POSSIBILITY OF SUCH DAMAGE.

 *____________________________________________________________________________*|
 *
 * $Source: Hello.c$
 * $Date: Sun Aug 10 06:41:30 1997$
 *
 Description:
	Have a look at server values and environment variables.
	
	Speaks HTTP/1.0
\*____________________________________________________________________________*/
/* $SourceTop:$ */

#include &ltstdlib.h>
#include &ltstdio.h>
#include &lttime.h>

/*____________________________________________________________________________*\
 *
 Description:
\*____________________________________________________________________________*/
extern char **_environ;

/*____________________________________________________________________________*\
 *
 Function:
 Synopsis:
 Description:
\*____________________________________________________________________________*/
void WriteEnv( int iLen, char *pInput )
{
	const char *pCurrent;
	int iIndex;

	printf("Content-Type: text/html\n");
	printf("\n" );
	printf("&ltHTML>\n");
	printf("&ltTITLE>View <A HREF="/pidocs/Objects/HTTP.html#CGI">CGI</A> Environment&lt/TITLE>\n");
	printf("&ltBODY>\n");
	printf("&ltH2>View <A HREF="/pidocs/Objects/HTTP.html#CGI">CGI</A> Environment&lt/H2>\n");
	printf("&ltBR>Stdin data length:&ltBR>&ltB>%d&lt/B>&ltBR>\n", iLen );
	if ( iLen>0 && pInput )
		{
		printf("&ltBR>Stdin data:&ltBR>&ltB>%s&lt/B>&ltBR>\n", pInput );
		};
	printf("&ltBR>Environment variables follow:&ltBR>\n");
	printf("&ltBR>&ltB>\n");

	for( iIndex = 0; ; iIndex++ )
		{
		pCurrent = _environ[iIndex];
		if ( !pCurrent ) { break; };

		printf( "&ltCODE>%s&lt/CODE>&ltBR>\n", pCurrent );
		};
	printf("&ltBR>&lt/B>\n");

	printf("&lt/BODY>\n");
}

/*____________________________________________________________________________*\
 *
 Function:
 Synopsis:
 Description:
\*____________________________________________________________________________*/
int main( int iArgc, const char *ppArgv[] )
{
	const char *pContentLength;
	int iInLen;
	char *pInputData = 0;

	pContentLength = getenv( "CONTENT_LENGTH" );
	iInLen = atoi( pContentLength ? pContentLength : 0 );

	/*
	** Allocate buffer for data
	*/
	if ( iInLen>0 )
		{ pInputData = (char *)malloc( iInLen+1 );  };

	/*
	** Read data
	*/
	if ( pInputData )
		{
		iInLen = fread( pInputData, sizeof( char ), iInLen, stdin );
		pInputData[iInLen] = '\0';
		};

	WriteEnv( iInLen, pInputData );

	return 0;
}

</PRE></BODY></HTML>